\documentclass[a4paper]{article}
\usepackage[english]{babel}
\usepackage[T1]{fontenc}
\usepackage[a4paper, top=0.75cm, bottom=0.75cm, left=2cm, right=2cm]{geometry}
\usepackage{listings}
\usepackage{inconsolata}
\pagenumbering{gobble}
\lstset{frame=single, showstringspaces=false, columns=fixed, basicstyle={\ttfamily}, commentstyle={\it}, numbers=left, tabsize=4}
\begin{document}
\lstset{title=Contents of \texttt{README}}
\lstset{
  language=,
  morekeywords={NAME, SYNOPSIS, DESCRIPTION, NOTES, EXAMPLES, AUTHOR, COPYRIGHT},
  moredelim=[is][\it]{<|}{|>},
  moredelim=[is][\bf]{<:}{:>}
}
\begin{lstlisting}
NAME
        <:forkring:> - create a network of processes with ring topology.

SYNOPSIS
        typedef void <|func|>(int input, int output, void *data);
        void <:forkIO:>(<|Pipe|> in, <|Pipe|> out, <|func|> f, void *data);
            Creates a fork which runs the <|func|> f with
                input  in.r
                output out.w
                data   data
            And handles error checking and closing unneeded pipe ends.
        
DESCRIPTION
        A simple demonstration program, which creates K processes,
        each connected to its peers, which pass a value in a ring,
        decreasing it, until it hits 0. Then it gracefully stops.

AUTHOR
        Implemented by Stotskii Andrey (ruro).

COPYRIGHT
        Copyright (c) 2017 Free Software Foundation, Inc.  License GPLv3+:
        GNU GPL version 3 or later <http://gnu.org/licenses/gpl.html>.
        This is free software: you are free to change and redistribute it.
        There is NO WARRANTY, to the extent permitted by law.
\end{lstlisting}
\lstset{title=Contents of \texttt{makefile}}
\lstset{language={[gnu]make}}
\begin{lstlisting}
CFLAGS= -Wall -O3 -std=gnu99
LDFLAGS= -s -lm -lpthread
CC=gcc

vpath %.c src
vpath %.h src

examples:   forkring.h terminator.h forkring.o terminator.o forkshare.o
forkring.o: forkring.h terminator.h
terminator.o:          terminator.h forkshare.h
forkshare.o:           terminator.h forkshare.h

.PHONY:libs
libs: forkring.o terminator.o forkshare.o

.PHONY:clean
clean:
	rm -f *.o examples
\end{lstlisting}
\lstset{language={[ANSI]C}}
\lstset{literate={float.}{float.}6}
\lstset{morekeywords={size_t, ssize_t, bool, pid_t, func, sem_t, Pipe, Task, TaskStream, Worker, Swarm}}
\lstset{moredelim=[s][\it]{__}{__}}
\lstset{moredelim=[s][\it]{((}{))}}
\lstset{title=Contents of \texttt{src/forkring.h}}
\begin{lstlisting}
#ifndef _FORKRING_H
#define _FORKRING_H

typedef struct {
    int r;
    int w;
} Pipe;

typedef void func(int, int, void *);

void forkIO(Pipe, Pipe, func, void *) __attribute__(( nonnull (3) ));
Pipe mkPipe(void);

#endif
\end{lstlisting}
\newpage
\lstset{title=Contents of \texttt{src/forkring.c}}
\begin{lstlisting}
#include <errno.h>
#include <stdlib.h>
#include <unistd.h>

#include "forkring.h"
#include "terminator.h"

Pipe mkPipe(void)
{
    int fd[2];
    if (pipe(fd))
        terminate(errno, "Couldn't create a pipe.\n");
    Pipe ret = { .r = fd[0], .w = fd[1] };
    return ret;
}

void forkIO(Pipe in, Pipe out, func run, void *data)
{
    pid_t p = fork();
    if (p == -1)
        terminate(errno, "Couldn't fork.\n");
    if (!p)
    {
        // Child.
        if (close(in.w))
            terminate(errno, "Couldn't close pipe end.\n");
        if (close(out.r))
            terminate(errno, "Couldn't close pipe end.\n");
        run(in.r, out.w, data);
        exit(0);
    }
}
\end{lstlisting}
\newpage
\lstset{title=Contents of \texttt{src/examples.c}}
\begin{lstlisting}
#include <unistd.h>
#include <errno.h>
#include <stdio.h>
#include <inttypes.h>
#include <signal.h>
#include <sys/wait.h>
#include <sys/types.h>

#include "forkring.h"
#include "terminator.h"

#define sread(r, s)  ( read(r, &s, sizeof(s)) != sizeof(s))
#define swrite(w, s) (write(w, &s, sizeof(s)) != sizeof(s))

func pass;
void pass(int i, int o, void *data)
{
    // Get pid and in-order number.
    intmax_t self = (intmax_t)getpid();
    size_t id = *(size_t *)data;
    announce("[%6jd|%4zu] Starting process.\n", self, id);
    while (1)
    {
        // Get counter from previous process.
        ssize_t counter;
        if (sread(i, counter))
            terminate(errno, "Couldn't read from pipe.\n");
        if (counter)
            announce("[%6jd|%4zu] Counter is %zd\n", self, id, counter);
        counter = counter ? counter - 1 : 0;

        // Write to next process.
        if (swrite(o, counter))
            terminate(errno, "Couldn't write to pipe.\n");

        // Stop, when 0 is reached.
        if (!counter)
            break;
    }
    announce("[%6jd|%4zu] Stopping...\n", self, id);
}

\end{lstlisting}
\newpage
\begin{lstlisting}[firstnumber=last]
int main(void)
{
    // Make stdout and stderr atomic.
    atomize();

    // Get user input for process number.
    size_t K;
    announce("Please, input the number of processes in the ring:\n");
    if (scanf("%zu", &K) != 1)
        terminate(errno, "Couldn't get user input.\n");
    if (!K)
        terminate(0, "K should be greater than 0.\n");

    // Create first/last pipe.
    Pipe prev, next, first;
    first = mkPipe();
    prev.r = dup(first.r);
    prev.w = dup(first.w);

    // For all the processes except the last one.
    size_t i;
    for (i = 1; i < K; i++)
    {
        // Spawn process with input from prev and output to next.
        next = mkPipe();
        forkIO(prev, next, pass, &i);
        prev = next;
    }

    // Last process writes to first process.
    forkIO(prev, first, pass, &i);

    // Get user input for counter.
    size_t N;
    sleep(1);
    announce("Please, input the starting counter value:\n");
    if (scanf("%zu", &N) != 1)
        terminate(errno, "Couldn't get user input.\n");

    // Kick start cycle.
    if (swrite(first.w, N))
        terminate(errno, "Couldn't write to first process.\n");

    // Wait for all children to safely stop.
    while (wait(NULL) != -1 && errno != ECHILD);
}
\end{lstlisting}
\end{document}
